#!/usr/bin/perl
BEGIN {
	require "fatlib.pl";
}

use utf8;
use strict;

my $VER="V.0.002n(nanakochi123456)";
my $tarball="denkiyohou110620.tar.gz";
my $adminmail='nanami@daiba.cx';
my $adminname='でんき予報速報サイト管理人';
my $date_format="Y-m-d H:i:s";

my $data_update=<<EOM;
<li>2011/6/20 16:00 仮データのみ登録</li>
EOM

my $engine_update=<<EOM;
<li>2011/6/20 21:40 計画停電で使用していたfatlib.pl の不要部分を削除した。</li>
<li>2011/6/20 20:00 メールアドレスをDNS参照でドメインを確認するようにした。</li>
<li>2011/6/20 16:00 メール登録機能、登録解除機能のみ実装した。</li>
EOM

my $tclock_update=<<EOM;
<li>2011/6/20 21:40 ログファイルをデフォルトで作らないようにした。</li>
<li>2011/6/20 10:00 新規作成</li>
EOM

$::modifier_sendmail="/var/qmail/bin/sendmail -t";

#------------
use CGI;
use Nana::Mail;
use Nana::YukiWikiDB;
use Encode;
use Digest::MD5 qw(md5_hex);

require "common.pl";

$VER=~s/\(.*//g;

if($ENV{QUERY_STRING} eq "tclock") {
	print <<EOM;
Content-type: text/plain

EOM
	open(R,"usage.txt");
	foreach(<R>) {
		print $_;
	}
	close(R);
	exit;
}
my $nojapaneseflg=0;
$nojapaneseflg=1 if($ENV{HTTP_ACCEPT_LANGUAGE}!~/ja/);
my $mobileflg=0;
$mobileflg=1 if($ENV{HTTP_USER_AGENT}=~/DoCoMo|UP\.Browser|KDDI|SoftBank|Voda[F|f]one|J\-PHONE|DDIPOCKET|WILLCOM|iPod|PDA|Mobile|Semulator/);

$mobileflg=0 if($ENV{QUERY_STRING}=~'p');
$mobileflg=1 if($ENV{QUERY_STRING}=~'m');
$nojapaneseflg=0 if($ENV{QUERY_STRING}=~'j');
$nojapaneseflg=1 if($ENV{QUERY_STRING}=~'e');

my $query=new CGI;

my($basehref, $basehost, $basepath)=&getbasehref;

my $mode=$query->param('m');
my $qr=$query->param('qr');

if($mode eq 'qr') {
	my $string=$query->param('str');
	&make_qrcode($string,$qr);
	exit;
}

my $file;
my @data;
my $hash;
my $mailfile;
my $subject;
my %db;
my $english_file="english.html";
my $english_mobile_file="english_mobile.html";
my $mobile_file="mobile.html";
my $pc_file="pc.html";
my $mobile_update_file="mobile_update.html";
my $mobile_setuden_file="mobile_setuden.html";

my $mail=$query->param('mail');
my $err;
if($mail ne '') {
	if(&mailchk($mail)) {
		my $mode;
		my $regunreg=$query->param('m');
		my $regist=$query->param('regist');
		my $unregist=$query->param('unregist');
		if($regist ne '' || $regunreg eq "regist") {
			$mode="regist";
		} elsif($unregist ne '' || $regunreg eq "unregist") {
			$mode="unregist";
		} else {
			$err="リクエストが異常です。";
			$file="error.html";
		}
		if($file eq '' && $mode eq "regist") {
			&open_db;
			@data=split(/\n/,$::database{$mail});
			foreach(@data) {
				my ($name,$value)=split(/=/,$_);
				$db{$name}=$value;
			}
			if($db{"registed"} eq 1) {
				&close_db;
				$file="error.html";
				$err="このメールアドレスは登録されています。";
			} elsif($::database{$mail} eq '') {
				$file="regist.html";
				$hash=md5_hex($mail . time . $ENV{REMOTE_ADDR});
				$mailfile="registconfirmmail.txt";
				$subject="でんき予報メール仮登録のお知らせ";
				$::database{$mail}=<<EOM;
mail=$mail
confirm=1
hash=$hash
EOM
				&close_db;
			}
		} elsif($file eq '' && $mode eq "unregist") {
			&open_db;
			@data=split(/\n/,$::database{$mail});
			foreach(@data) {
				my ($name,$value)=split(/=/,$_);
				$db{$name}=$value;
			}
			if($db{"confirm"}  eq 1) {
				$file="confirmnow.html";
			} elsif($db{"registed"} eq 1) {
				$file="unregist.html";
				$mailfile="unregistconfirmmail.txt";
				$subject="でんき予報メール仮登録解除のお知らせ";
				$::database{$mail}=<<EOM;
mail=$db{mail}
registed=1
hash=$db{hash}
EOM
				$hash=$db{hash};
			} else {
				$err="登録されていないメールアドレスです。";
				$file="error.html";
			}
			&close_db;
		}
	} else {
		$err="メールアドレスが正しくありません。";
	}
}

my $qhash=$query->param('x');
my $mode=$query->param('mode');

if($mode eq "confirm" && $qhash ne '') {
	&open_db;
	foreach my $email(keys %::database) {
		@data=split(/\n/,$::database{$email});
		foreach(@data) {
			my ($name,$value)=split(/=/,$_);
			$db{$name}=$value;
		}
		if($db{"confirm"} eq 1 && $db{"hash"} eq $qhash) {
			$::database{$email}=<<EOM;
mail=$db{mail}
registed=1
hash=$db{hash}
EOM
			$mail=$db{mail};
			$file="regist_confirm.html";
			$mailfile="registmail.txt";
			$subject="でんき予報メール登録のお知らせ";
			&close_db;
			Nana::Mail::toadmin("Add",$mail,$adminmail);
 			last;
		}
	}
	if($mail eq '') {
		$err="メールアドレスが正しくないか、メールに添付されたアドレスにきちんとアクセスできていません。";
		$file="error.html";
	}
}

if($mode eq "unregistconfirm" && $qhash ne '') {
	&open_db;
	foreach my $email(keys %::database) {
		@data=split(/\n/,$::database{$email});
		foreach(@data) {
			my ($name,$value)=split(/=/,$_);
			$db{$name}=$value;
		}
		if($db{"registed"} eq 1 && $db{"hash"} eq $qhash) {
			$mail=$db{mail};
			delete $::database{$mail};
			$file="unregist_confirm.html";
			$mailfile="unregist.txt";
			$subject="でんき予報メール登録解除完了のお知らせ";
			&close_db;
			Nana::Mail::toadmin("Del",$mail,$adminmail);
			last;
		}
	}
	if($mail eq '') {
		$err="メールアドレスが正しくないか、メールに添付されたアドレスにきちんとアクセスできていません。";
		$file="error.html";
	}
}

&gzip_compress("Content-type: text/html; charset=utf-8");
my $body;
my $kanaflg=0;
my $updatetitle;
if($file eq '') {
	if($nojapaneseflg) {
		if($mobileflg) {
			$file=$english_mobile_file;
		} else {
			$file=$english_file;
		}
	} elsif($ENV{QUERY_STRING}=~/^mju/) {
		$file=$mobile_update_file;
		$kanaflg=1;
	} elsif($ENV{QUERY_STRING}=~/^mjs/) {
		$file=$mobile_setuden_file;
		$kanaflg=1;
	} elsif($mobileflg) {
		$file=$mobile_file;
	} else {
		$file=$pc_file;
	}
}

if(open(R,"<:utf8","$file")) {
	foreach(<R>) {
		$body.=&convert($_);
	}
	close(R);
} else {
	$body="$file not found. sorry.";
}
if($kanaflg) {
	$body=&z2h($body);
}
print "$body\n";
close(STDOUT);

if($mailfile ne '') {
	$body='';
	Nana::Mail::getremotehost;
	if(open(R,"<:utf8","$mailfile")) {
		foreach(<R>) {
			$body.=&convert($_);
		}
		close(R);
		Nana::Mail::send(
			to=>$mail, to_name=> $mail . "様",
			from=>$adminmail, from_name=>$adminname,
			subject=>$subject,data=>$body);
	}
}
exit;

sub convert {
	my($text)=shift;
	if(/\@\@/) {
		$text=~s/\@\@VER\@\@/$VER/;
		$text=~s/\@\@ERR\@\@/$err/;
		$text=~s/\@\@INCLUDE\=\"(.+)\"\@\@/@{[&include($1)]}/;
		$text=~s/\@\@QRCODEEN\@\@/@{[&qrcode_link_en]}/;
		$text=~s/\@\@QRCODEJP\@\@/@{[&qrcode_link]}/;
		$text=~s/\@\@DATAUPDATE\@\@/$data_update/;
		$text=~s/\@\@ENGINEUPDATE\@\@/$engine_update/;
		$text=~s/\@\@TCLOCKUPDATE\@\@/$tclock_update/;
		$text=~s/\@\@TARBALL\@\@/$tarball/;
		$text=~s/\@\@MAIL\@\@/$mail/;
		$text=~s/\@\@HASH\@\@/$hash/;
		$text=~s/\@\@URL\@\@/$basehost$basepath/;
		$text=~s/\@\@REMOTE_ADDR\@\@/$ENV{REMOTE_ADDR}/;
		$text=~s/\@\@REMOTE_HOST\@\@/$ENV{REMOTE_HOST}/;
		$text=~s/\@\@DATETIME\@\@/@{[&date($date_format)]}/;
	}
	return $text;
}

sub include {
	my $file=shift;
	my $body="";
	if(open(I,"<:utf8","$file")) {
		my $div=$file;
		$div=~s/\.//g;
		$body.=<<EOM;
<div id="$div">
EOM
		foreach(<I>) {
			$body.=$_;
		}
		close(I);
		$body.="</div>\n";
	}
	$body;
}

sub qrcode_link {
	my $string=&enc("$basehost$basepath");
	if(&load_module("GD") && &load_module("GD::Barcode")) {
		return <<FIN;
携帯へURLを送るには、こちらのQRコードをご利用下さい。<br />
<img alt="QRCode" src="$basehost$basepath/?m=qr\&amp;str=$string" />

FIN
	}
	'';
}

sub qrcode_link_en {
	my $string=&enc("$basehost$basepath?e");
	if(&load_module("GD::Barcode")) {
		return <<FIN;
If you have mobile phone to transfer this site, use this barcode.
<br />
<img alt="QRCode" src="$basehost$basepath/?m=qr\&amp;str=$string" />

FIN
	}
	'';
}

sub date {
	my ($format, $tm, $gmtime) = @_;
	my %weekday;
	my %ampm;

	# yday:0-365 $isdst Summertime:1/not:0
	my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = 
		$gmtime ne '' && @_ > 2
			? ($tm+0 > 0 ? gmtime($tm) : gmtime(time))
			: ($tm+0 > 0 ? localtime($tm) : localtime(time));

	$year += 1900;
	my $hr12=$hour=>12 ? $hour-12:$hour;
	# year
	$format =~ s/Y/$year/ge;	# Y:4char ex)1999 or 2003

	# month
	$mon++;									# mon is 0 to 11 add 1
	$format =~ s/n/$mon/ge;					# n:1-12
	$mon = "0" . $mon if ($mon < 10);
	$format =~ s/m/$mon/ge;					# m:01-12

	# day
	$format =~ s/j/$mday/ge;				# j:1-31
	$mday = "0" . $mday if ($mday < 10);
	$format =~ s/d/$mday/ge;				# d:01-31

	# hour
	$hour = "0" . $hour if ($hour < 10);
	$format =~ s/H/$hour/ge;				# H:00-23

	# minutes
	$min = "0" . $min if ($min < 10);
	$format =~ s/i/$min/ge;					# i:00-59

	# second
	$sec = "0" . $sec if ($sec < 10);
	$format =~ s/s/$sec/ge;					# s:00-59

	return $format;
}
